﻿//fragment program
//"CREDIT": "by VIDVOX" https://www.interactiveshaderformat.com/sketches/207
#version 120 

uniform sampler2D Tex0;
uniform vec2 resolution;
uniform vec2 center;
uniform float sides;
uniform float angle;
uniform float slidex;
uniform float slidey;
const float tau = 6.28318530718;

void main() 
{
  // normalize to the center
	vec2 loc = resolution * vec2 (gl_TexCoord[0].x,gl_TexCoord[0].y);
	float r = distance(center, loc);
	float a = atan ((loc.y-center.y),(loc.x-center.x));
	
	// kaleidoscope
	a = mod(a, tau/sides);
	a = abs(a - tau/sides/2.);
	
	loc.x = r * cos(a + tau * angle);
	loc.y = r * sin(a + tau * angle);
	
	loc = (center + loc) / resolution;
	
	loc.x = mod(loc.x + slidex, 1.0);
	loc.y = mod(loc.y + slidey, 1.0);

	// sample the image
	if (loc.x < 0.0)	{
		loc.x = mod(abs(loc.x), 1.0);
	}
	if (loc.y < 0.0)	{
		loc.y = mod(abs(loc.y),1.0);
	}
	if (loc.x > 1.0)	{
		loc.x = mod(abs(1.0-loc.x),1.0);
	}
	if(loc.y > 1.0)	{
		loc.y = mod(abs(1.0-loc.y),1.0);	
	}
	gl_FragColor = texture2D(Tex0, loc);;
}